<template>
	<v-row class="search-box">
		<v-col v-if="label" :cols="labelCols">
			<label for="" class="search-box-label">
				<v-icon x-small color="primary" class="mr-1">mdi-record-circle</v-icon>
				{{ label }}
			</label>
		</v-col>
		<v-col :cols="label ? textCols : ''">
			<v-select
				v-model="selectValue"
				:items="searchParam[parentPrgmId].readObjInfoList"
				item-text="readObjNm"
				item-value="idx"
				solo
				outlined
				:hide-details="true"
				append-icon="mdi-chevron-down"
				class="v-select__custom"
			></v-select>
		</v-col>
	</v-row>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
export default {
	props: {
		parentPrgmId: {
			type: String,
			require: true,
		},
		autoLoad: {
			type: Boolean,
			require: false,
			default: true,
		},
		label: {
			type: String,
			require: false,
			default: '대상',
		},
		textCols: {
			type: Number,
			require: false,
			default: 7,
		},
		labelCols: {
			type: Number,
			require: false,
			default: 4,
		},
	},
	data() {
		return {};
	},
	computed: {
		...mapState({
			searchParam: state => state.pageData,
		}),
		selectValue: {
			get() {
				return this.searchParam[this.parentPrgmId].readObjInfo;
			},
			set(value) {
				return this.setPageData({ readObjInfo: value });
			},
		},
	},
	async created() {
		if (this.autoLoad) {
			await this.initData();
		}
	},
	methods: {
		...mapMutations({ setPageData: 'setPageData' }),
		...mapActions({
			postApi: 'modules/list/postApi',
			postUpdateApi: 'modules/list/postUpdateApi',
			postApiReturn: 'modules/list/postApiReturn',
			setTree: 'modules/list/setTree',
			chkOpenTabList: 'chkOpenTabList',
		}),
		async initData() {
			var readObjInfoList = await this.postApiReturn({
				apiKey: 'selectReadObjInfo',
				resKey: 'readObjInfoData',
				sendParam: {
					grpCd: 'MTT_PROD',
					useFg: '1',
				},
			});

			var tempIdx = 0;
			readObjInfoList.map(item => {
				item.idx = tempIdx++;
			});

			this.setPageData({ readObjInfo: 0, readObjInfoList: readObjInfoList });
		},
	},
};
</script>

<style></style>
